Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.3 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## javolution.xml.sax
Class XMLReaderImpl

    java.lang.Object
      javolution.xml.sax.XMLReaderImpl

All Implemented Interfaces:
  Reusable, XMLReader

    public class XMLReaderImpl

extends java.lang.Object
implements XMLReader, Reusable

This class provides a real-time SAX2-like XML parser; this parser is extremely fast and does not create temporary objects (no garbage generated and no GC interruption).

The parser is implemented as a SAX2 wrapper around `XMLStreamReaderImpl` and share the same characteristics.

Note: This parser is a SAX2-like parser with the `java.lang.String` type replaced by `CharArray`/`CharSequence` in the `ContentHandler`, `Attributes` interfaces and `DefaultHandler` base class. If a standard SAX2 or JAXP parser is required, you may consider using the wrapping class `SAX2ReaderImpl`. Fast but not as fast as `java.lang.String` instances are dynamically allocated while parsing.

Version:
  4.0, June 16, 2006
Author:
  Jean-Marie Dautelle

Constructor Summary
`XMLReaderImpl()` Default constructor.

Method Summary
`ContentHandler` | `getContentHandler()` Return the current content handler.
`org.xml.sax.DTDHandler` | `getDTDHandler()` Return the current DTD handler.
`org.xml.sax.EntityResolver` | `getEntityResolver()` Return the current entity resolver.
`org.xml.sax.ErrorHandler` | `getErrorHandler()` Return the current error handler.
`boolean` | `getFeature(java.lang.String name)` Look up the value of a feature flag.
`java.lang.Object` | `getProperty(java.lang.String name)` Look up the value of a property.
`void` | `parse(org.xml.sax.InputSource input)` Parse an XML document.
`void` | `parse(java.io.InputStream in)` Parses an XML document from the specified input stream (encoding retrieved from input source and the XML prolog if any).
`void` | `parse(java.io.InputStream in, java.lang.String encoding)` Parses an XML document from the specified input stream and encoding.
`void` | `parse(java.io.Reader reader)` Parses an XML document using the specified reader.
`void` | `parse(java.lang.String systemId)` Parse an XML document from a system identifier (URI).
`void` | `reset()` Resets the internal state of this object to its default values.
`void` | `setContentHandler(ContentHandler handler)` Allow an application to register a content event handler.
`void` | `setDTDHandler(org.xml.sax.DTDHandler handler)` Allow an application to register a DTD event handler.
`void` | `setEntityResolver(org.xml.sax.EntityResolver resolver)` Allow an application to register an entity resolver.
`void` | `setErrorHandler(org.xml.sax.ErrorHandler handler)` Allow an application to register an error event handler.
`void` | `setFeature(java.lang.String name, boolean value)` Set the value of a feature flag.
`void` | `setProperty(java.lang.String name, java.lang.Object value)` Set the value of a property.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XMLReaderImpl

    public XMLReaderImpl()

  Default constructor.

Method Detail

### parse

    public void parse(java.io.InputStream in)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Parses an XML document from the specified input stream (encoding retrieved from input source and the XML prolog if any).

  Parameters:
    `in` - the input stream with unknown encoding.
  Throws:
    `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception.
    `java.io.IOException` - an IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

### parse

    public void parse(java.io.InputStream in,
                      java.lang.String encoding)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Parses an XML document from the specified input stream and encoding.

  Parameters:
    `in` - the input stream.
    `encoding` - the input stream encoding.
  Throws:
    `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception.
    `java.io.IOException` - an IO exception from the parser, possibly from a byte stream or character stream supplied by the application.

### parse

    public void parse(java.io.Reader reader)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Parses an XML document using the specified reader.

  Parameters:
    `reader` - the document reader.
  Throws:
    `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception.
    `java.io.IOException` - an IO exception from the parser, possibly from a byte stream or character stream supplied by the application.
  See Also:
    `UTF8StreamReader`, `UTF8ByteBufferReader`, `CharSequenceReader`

### parse

    public void parse(org.xml.sax.InputSource input)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Description copied from interface: `XMLReader`
  Parse an XML document.

  The application can use this method to instruct the XML reader to begin parsing an XML document from any valid input source (a character stream, a byte stream, or a URI).

  Applications may not invoke this method while a parse is in progress (they should create a new XMLReader instead for each nested XML document). Once a parse is complete, an application may reuse the same XMLReader object, possibly with a different input source. Configuration of the XMLReader object (such as handler bindings and values established for feature flags and properties) is unchanged by completion of a parse, unless the definition of that aspect of the configuration explicitly specifies other behavior. (For example, feature flags or properties exposing characteristics of the document being parsed.)

  During the parse, the XMLReader will provide information about the XML document through the registered event handlers.

  This method is synchronous: it will not return until parsing has ended. If a client application wants to terminate parsing early, it should throw an exception.

  Specified by:
    `parse` in interface `XMLReader`
  Parameters:
    `input` - The input source for the top-level of the XML document.
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
    `java.io.IOException`
  See Also:
    `InputSource`, `XMLReader.setEntityResolver(org.xml.sax.EntityResolver)`, `XMLReader.setDTDHandler(org.xml.sax.DTDHandler)`, `XMLReader.setContentHandler(javolution.xml.sax.ContentHandler)`, `XMLReader.setErrorHandler(org.xml.sax.ErrorHandler)`

### parse

    public void parse(java.lang.String systemId)
               throws java.io.IOException,
                      org.xml.sax.SAXException

  Description copied from interface: `XMLReader`
  Parse an XML document from a system identifier (URI).

  This method is a shortcut for the common case of reading a document from a system identifier. It is the exact equivalent of the following:

       parse(new InputSource(systemId));

  If the system identifier is a URL, it must be fully resolved by the application before it is passed to the parser.

  Specified by:
    `parse` in interface `XMLReader`
  Parameters:
    `systemId` - The system identifier (URI).
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
    `java.io.IOException`
  See Also:
    `XMLReader.parse(org.xml.sax.InputSource)`

### setContentHandler

    public void setContentHandler(ContentHandler handler)

  Description copied from interface: `XMLReader`
  Allow an application to register a content event handler.

  If the application does not register a content handler, all content events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setContentHandler` in interface `XMLReader`
  Parameters:
    `handler` - The content handler.
  See Also:
    `XMLReader.getContentHandler()`

### getContentHandler

    public ContentHandler getContentHandler()

  Description copied from interface: `XMLReader`
  Return the current content handler.

  Specified by:
    `getContentHandler` in interface `XMLReader`
  Returns:
    The current content handler, or null if none has been registered.
  See Also:
    `XMLReader.setContentHandler(javolution.xml.sax.ContentHandler)`

### setErrorHandler

    public void setErrorHandler(org.xml.sax.ErrorHandler handler)

  Description copied from interface: `XMLReader`
  Allow an application to register an error event handler.

  If the application does not register an error handler, all error events reported by the SAX parser will be silently ignored; however, normal processing may not continue. It is highly recommended that all SAX applications implement an error handler to avoid unexpected bugs.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setErrorHandler` in interface `XMLReader`
  Parameters:
    `handler` - The error handler.
  See Also:
    `XMLReader.getErrorHandler()`

### getErrorHandler

    public org.xml.sax.ErrorHandler getErrorHandler()

  Description copied from interface: `XMLReader`
  Return the current error handler.

  Specified by:
    `getErrorHandler` in interface `XMLReader`
  Returns:
    The current error handler, or null if none has been registered.
  See Also:
    `XMLReader.setErrorHandler(org.xml.sax.ErrorHandler)`

### getFeature

    public boolean getFeature(java.lang.String name)
                       throws org.xml.sax.SAXNotRecognizedException,
                              org.xml.sax.SAXNotSupportedException

  Description copied from interface: `XMLReader`
  Look up the value of a feature flag.

  The feature name is any fully-qualified URI. It is possible for an XMLReader to recognize a feature name but temporarily be unable to return its value. Some feature values may be available only in specific contexts, such as before, during, or after a parse. Also, some feature values may not be programmatically accessible. (In the case of an adapter for SAX1 `Parser`, there is no implementation-independent way to expose whether the underlying parser is performing validation, expanding external entities, and so forth.)

  All XMLReaders are required to recognize the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes feature names.

  Typical usage is something like this:

       XMLReader r = new MySAXDriver();

                               // try to activate validation
       try {
         r.setFeature("http://xml.org/sax/features/validation", true);
       } catch (SAXException e) {
         System.err.println("Cannot activate validation.");
       }

                               // register event handlers
       r.setContentHandler(new MyContentHandler());
       r.setErrorHandler(new MyErrorHandler());

                               // parse the first document
       try {
         r.parse("http://www.foo.com/mydoc.xml");
       } catch (IOException e) {
         System.err.println("I/O exception reading XML document");
       } catch (SAXException e) {
         System.err.println("XML exception reading document.");
       }

  Implementors are free (and encouraged) to invent their own features, using names built on their own URIs.

  Specified by:
    `getFeature` in interface `XMLReader`
  Parameters:
    `name` - The feature name, which is a fully-qualified URI.
  Returns:
    The current value of the feature (true or false).
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - If the feature value can't be assigned or retrieved.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the feature name but cannot determine its value at this time.
  See Also:
    `XMLReader.setFeature(java.lang.String, boolean)`

### setFeature

    public void setFeature(java.lang.String name,
                           boolean value)
                    throws org.xml.sax.SAXNotRecognizedException,
                           org.xml.sax.SAXNotSupportedException

  Description copied from interface: `XMLReader`
  Set the value of a feature flag.

  The feature name is any fully-qualified URI. It is possible for an XMLReader to expose a feature value but to be unable to change the current value. Some feature values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

  All XMLReaders are required to support setting http://xml.org/sax/features/namespaces to true and http://xml.org/sax/features/namespace-prefixes to false.

  Specified by:
    `setFeature` in interface `XMLReader`
  Parameters:
    `name` - The feature name, which is a fully-qualified URI.
    `value` - The requested value of the feature (true or false).
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - If the feature value can't be assigned or retrieved.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the feature name but cannot set the requested value.
  See Also:
    `XMLReader.getFeature(java.lang.String)`

### getProperty

    public java.lang.Object getProperty(java.lang.String name)
                                 throws org.xml.sax.SAXNotRecognizedException,
                                        org.xml.sax.SAXNotSupportedException

  Description copied from interface: `XMLReader`
  Look up the value of a property.

  The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but temporarily be unable to return its value. Some property values may be available only in specific contexts, such as before, during, or after a parse.

  XMLReaders are not required to recognize any specific property names, though an initial core set is documented for SAX2.

  Implementors are free (and encouraged) to invent their own properties, using names built on their own URIs.

  Specified by:
    `getProperty` in interface `XMLReader`
  Parameters:
    `name` - The property name, which is a fully-qualified URI.
  Returns:
    The current value of the property.
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - If the property value can't be assigned or retrieved.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot determine its value at this time.
  See Also:
    `XMLReader.setProperty(java.lang.String, java.lang.Object)`

### setProperty

    public void setProperty(java.lang.String name,
                            java.lang.Object value)
                     throws org.xml.sax.SAXNotRecognizedException,
                            org.xml.sax.SAXNotSupportedException

  Description copied from interface: `XMLReader`
  Set the value of a property.

  The property name is any fully-qualified URI. It is possible for an XMLReader to recognize a property name but to be unable to change the current value. Some property values may be immutable or mutable only in specific contexts, such as before, during, or after a parse.

  XMLReaders are not required to recognize setting any specific property names, though a core set is defined by SAX2.

  This method is also the standard mechanism for setting extended handlers.

  Specified by:
    `setProperty` in interface `XMLReader`
  Parameters:
    `name` - The property name, which is a fully-qualified URI.
    `value` - The requested value for the property.
  Throws:
    `org.xml.sax.SAXNotRecognizedException` - If the property value can't be assigned or retrieved.
    `org.xml.sax.SAXNotSupportedException` - When the XMLReader recognizes the property name but cannot set the requested value.

### setEntityResolver

    public void setEntityResolver(org.xml.sax.EntityResolver resolver)

  Description copied from interface: `XMLReader`
  Allow an application to register an entity resolver.

  If the application does not register an entity resolver, the XMLReader will perform its own default resolution.

  Applications may register a new or different resolver in the middle of a parse, and the SAX parser must begin using the new resolver immediately.

  Specified by:
    `setEntityResolver` in interface `XMLReader`
  Parameters:
    `resolver` - The entity resolver.
  See Also:
    `XMLReader.getEntityResolver()`

### getEntityResolver

    public org.xml.sax.EntityResolver getEntityResolver()

  Description copied from interface: `XMLReader`
  Return the current entity resolver.

  Specified by:
    `getEntityResolver` in interface `XMLReader`
  Returns:
    The current entity resolver, or null if none has been registered.
  See Also:
    `XMLReader.setEntityResolver(org.xml.sax.EntityResolver)`

### setDTDHandler

    public void setDTDHandler(org.xml.sax.DTDHandler handler)

  Description copied from interface: `XMLReader`
  Allow an application to register a DTD event handler.

  If the application does not register a DTD handler, all DTD events reported by the SAX parser will be silently ignored.

  Applications may register a new or different handler in the middle of a parse, and the SAX parser must begin using the new handler immediately.

  Specified by:
    `setDTDHandler` in interface `XMLReader`
  Parameters:
    `handler` - The DTD handler.
  See Also:
    `XMLReader.getDTDHandler()`

### getDTDHandler

    public org.xml.sax.DTDHandler getDTDHandler()

  Description copied from interface: `XMLReader`
  Return the current DTD handler.

  Specified by:
    `getDTDHandler` in interface `XMLReader`
  Returns:
    The current DTD handler, or null if none has been registered.
  See Also:
    `XMLReader.setDTDHandler(org.xml.sax.DTDHandler)`

### reset

    public void reset()

  Description copied from interface: `Reusable`
  Resets the internal state of this object to its default values.

  Specified by:
    `reset` in interface `Reusable`

Overview | Package | Class | Tree | Deprecated | Index | Help
| J avolution v5.3 (J2SE 1.5+)
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005 - 2009 Javolution.